/* ணࠬ ࠡ  ⥫ﬨ 㭨쭮  DS1990A-F5
    (  䨪樮묨 砬 iButton).
    ⠭   11.059  */
#pragma language = extended
#include <include\io51fx.h>
#include <include\defines.h>
#include <include\settings.h>
#include <include\pins.h>
#include <include\vars.h>

extern uchar OrMask, AndMask;

extern uchar ReadRandom (uint Adr);
extern uchar ReadCurrent (uchar BlockAdr);
extern void WriteByte (uint Adr, uchar Byte);
extern void WriteBlock (uint Adr, uchar NumBytes, uchar* Src);

/*xdata uchar RDat [2048];

void ReadAll (void)
  {
   uint i;

   RDat[0] = ReadRandom(0);
   for (i=1;i<2048;i++)
      RDat[i] = ReadCurrent(i/256);
  }*/

void SetRedFlash (uchar OnDuration, uchar OffDuration)
  {
   OnRed  = OnDuration;
   OffRed = OffDuration;

   if (OnRed == 0)
      RED = TRUE;
  }

void setInt (void)
/* ன ⥬ 뢠  窮 8751 */
  {
/* TMOD:  ० ࠡ ⠩஢/稪 (CT0, CT1). CT0 ᯮ㥬 
          ନ஢ ६ ࢠ ⨧樨,
           CT1  ᯮ */
   #define CT1_16       0x10       /* 16- ०                 */
   #define CT1_8        0x20       /*  8- ०  ⮧㧪 */
   #define CT0_16       0x01       /* 16- ०                 */
   #define CT0_8        0x02       /*  8- ०  ⮧㧪 */
   TMOD = CT1_8+CT0_16;
   /* ந ⠩ C/T0 */
   TH0 = T0_CONST/256;
   TL0 = (uchar)T0_CONST;
/* IE:    ࠧ襭 뢠 */
   #define ENL_INT0  0x01
   #define ENL_INT1  0x04
   #define ENL_SERIA 0x10
   #define ENL_TMR0  0x02
   #define ENL_TMR1  0x08
   IE = ENL_TMR0;

   EA = TRUE;
  }

void Clea24LC16 (void)
  {
   uchar ii;

   OrMask  = 0xFF;      /*  24C16   窨 */
   for (ii=0;ii<(2048/16);ii++)
      WriteBlock(ii*16, 16, (uchar*)0);
   OrMask  = 0x00;      /* OrMask  ⪫砥 */

   MasterPresent = FALSE;       /* -    */
   WriteByte (aMasterPresent, MasterPresent);
   OpenTime = 1;                /* ६ 뢠 1 ᥪ㭤 */
   WriteByte (aOpenTime, OpenTime);
   NumKeys = 0;                 /*      */
   WriteByte (aNumKeys  , *((uchar*)&NumKeys  ));
   WriteByte (aNumKeys+1, *((uchar*)&NumKeys+1));
  }

void LoadFromEE (void)
  {
   MasterPresent = (ReadRandom(aMasterPresent) == TRUE);
   OpenTime      =  ReadRandom(aOpenTime);
   *((uchar*)&NumKeys  ) = ReadRandom (aNumKeys);
   *((uchar*)&NumKeys+1) = ReadCurrent(aNumKeys/256);
  }

void Beep (void)
  {
   uchar CopyCnt;

   ZUMM = FALSE;
   CopyCnt = Cnt50ms;
   while (CopyCnt==Cnt50ms){}
   while (CopyCnt!=Cnt50ms){}  /* ⥫쭮  1 ᥪ㭤 */
   ZUMM = TRUE;
  }

void OpenDoor (void)
  {
   OpenTimeCnt = OpenTime * (1000/50);
  }

void ReadKey (uint Adr)
  {
   uchar i;

   for (i=0;i<4;i++)
      *((uchar*)&KeyF+i) = ReadRandom (Adr+i);
  }

void AddKey (void)
  {
   WriteBlock(NumKeys*4, 4, (uchar*)&KeyA);
   NumKeys++;
   WriteByte (aNumKeys  , *((uchar*)&NumKeys  ));
   WriteByte (aNumKeys+1, *((uchar*)&NumKeys+1));
  }

bit KeyExist (void)
/* ᫨  KeyA   24C16,  頥 TRUE.
    ⮬ IdxA ࠭  ()   24C16 */
  {
   uint i;
   bit Result;

   Result = FALSE;
   for (i=0;i<NumKeys;i++)
     {
      ReadKey (i*4);
      if (KeyA==KeyF)
        {
         Result = TRUE;
         IdxA = i;
         break;
        }
     }
   return Result;
  }

void DeleteKey (void)
/* 㤠  24C16  KeyA.  ⮬    24C16, 室騥
   "ࠢ", ᬥ   4  */
  {
   if (KeyExist())
     {
      IdxF = IdxA+1;
      while (IdxF<NumKeys)
        {
         ReadKey   (IdxF*4);
         WriteBlock(IdxA*4, 4, (uchar*)&KeyF);
         IdxA++;
         IdxF++;
        }
      KeyF = 0xFFFFFFFF;
      WriteBlock(IdxA*4, 4, (uchar*)&KeyF);
      NumKeys--;
      WriteByte (aNumKeys  , *((uchar*)&NumKeys  ));
      WriteByte (aNumKeys+1, *((uchar*)&NumKeys+1));
     }
  }

main()
  {
   RED   = FALSE;
   GREEN = FALSE;

   OrMask  = 0x00;      /* OrMask  ⪫砥 */
   AndMask = 0xFF;      /* AndMask ⪫砥 */
   Cnt50ms = 1000/50;   /* ᪮쪮 ࠧ  㤥  Cnt50ms, ⮡
                           諮 1 ᥪ */
   setInt();
   TR0 = TRUE;

   LoadFromEE();
/*ReadAll();*/

   RED   = TRUE;
   GREEN = TRUE;
   ZUMM = TRUE;
   SetRedFlash(1,1);

   while(TRUE)
     {
      if (SW0)/* ६窠  */
        {
         if (ProgramMode)
           {
            if(KeyJoin)
              {
               if (JoinTime==0)
                 {
                  /*     ⮫쪮   */
                  JoinTime++;
                 }
               if (JoinTime==1)
                 {
                  if (!KeyExist())
                    {
                     RED = FALSE;
                     AddKey();
                     Beep();
                     RED = TRUE;
                    }
                  else
                    {
                     DeleteKey();
                     Beep();
                    }
                  if (!ButtPressed)
                    {
                     ProgramMode=FALSE;
                     SetRedFlash(1,1);
                    }
                  JoinTime++;
                 }
              }
            else
            /*   ᮥ */
              {
               if (JoinTime!=0)
                 {/*     ⮫쪮   */
                  JoinTime = 0;
                 }
              }
           }/* if: ProgramMode */
         else
           {/* else: not ProgramMode */
            SetRedFlash(1,1);
            if (ButtPressed)
               OpenDoor();
            if(KeyJoin)
              {
               if(KeyExist())
                  OpenDoor();
               if(ButtPressed && MasterPresent)
                 {
                  ReadKey(aMaster);
                  if (KeyA==KeyF)
                    {
                     ProgramMode = TRUE;
                     SetRedFlash(0,0);
                    }
                 }
              }
           }/* else: not ProgramMode */
        }/* if: ६窠  */
      else/* ६窠 ! */
        {
         ProgramMode = FALSE;
         SetRedFlash(10,10);
         if (KeyJoin)
         /*  ᮥ */
           {
            if (JoinTime==0)
              {
               /*     ⮫쪮   */
               JoinTime++;
              }
            if (JoinTime==MasterSetTime)
              {
               /* 짮⥫ ন   ᥪ㭤.
                     -箬 */
               ZUMM = FALSE;
               WriteBlock(aMaster, 4, (uchar*)&KeyA);
               WriteByte (aMasterPresent, TRUE);
               MasterPresent = TRUE;
               while(JoinTime<(MasterSetTime+MasterSetBeep)){}
               ZUMM = TRUE;
              }
            if (JoinTime==ClearTime)
              {
               /* 짮⥫ ন   29 ᥪ㭤.
                   頥  */
               ZUMM = FALSE;
               Clea24LC16();
               while(JoinTime<ClearTime+ClearBeep){}
               ZUMM = TRUE;
              }
           }
         else
         /*   ᮥ */
           {
            if (JoinTime!=0)
              {/*     ⮫쪮   */
               JoinTime = 0;
              }
           }
         if (ButtPressed)
           {
            if (ButtTime==0)
              {
               /*     ⮫쪮   */
               ButtTime++;
              }
            if (ButtTime==1)
              {
               ZUMM=FALSE;
               if (OpenTime==25)
                  OpenTime=1;
               else
                  OpenTime++;
               WriteByte (aOpenTime, OpenTime);
               Beep();
               ButtTime++;
              }
           }
         else
           {
            if (ButtTime!=0)
              {/*     ⮫쪮   */
               ButtTime = 0;
              }
           }
        }/* else: ६窠 ! */
     }
  }
